import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        String s = scanner.nextLine();
        String[] s1 = s.split(" ");
        int n = Integer.parseInt(s1[0]);
        long p = Long.parseLong(s1[1]);
        List<long[]> l = new ArrayList<>();
        long sm = 0;
        long zmin = 10 ^ 9;
        long sms_min_voltage = 0;
        long sms_b = 0;
        for (int i = 0; i < n; i++) {
            String[] s2 = scanner.nextLine().split(" ");
            long z = Long.parseLong(s2[0]), a = Integer.parseInt(s2[1]), b = Integer.parseInt(s2[2]);
            l.add(new long[] {z, a, b});
            zmin = Math.min(zmin, z);
            sm += a;
            sms_min_voltage += z * a;
            sms_b += b;
        }
        long x = (p - sms_min_voltage) / sms_b;
        if (sm * zmin > p) {
            x = p / sm;
        }
        while (sm(l, x) < p) x++;
        System.out.println(x);
    }

    public static long sm(List<long[]> l, long x) {
        long s = 0;
        for (long[] lo : l) {
            s += lo[1] * Math.min(x, lo[0]) + lo[2] * Math.max(0, x - lo[0]);
        }
        return s;
    }
}